/* $Id: utils.h,v 2.7 1993/06/04 14:46:52 klute Exp klute $ */

/* 
 * Copyright 1993 Rainer Klute <klute@irb.informatik.uni-dortmund.de>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation. The author makes no representations about the suitability
 * of this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 */

#if !defined (UTILS_H)
#define UTILS_H

#include <stdio.h>

#include "boolean.h"

#define ISO_Ae (0xc4)
#define ISO_Oe (0xd6)
#define ISO_Ue (0xdc)
#define ISO_ae (0xe4)
#define ISO_oe (0xf6)
#define ISO_ue (0xfc)
#define ISO_ss (0xdf)

#define IBM_Ae (0x8e)
#define IBM_Oe (0x99)
#define IBM_Ue (0x9a)
#define IBM_ae (0x84)
#define IBM_oe (0x94)
#define IBM_ue (0x81)
#define IBM_ss (0xe1)
#define ATARI_ss (0x9e)

#if defined (HANDLE_BROKEN_DATAFILES)
#define BROKEN_Ae ('[')
#define BROKEN_Oe ('\\')
#define BROKEN_Ue (']')
#define BROKEN_ae ('{')
#define BROKEN_oe ('|')
#define BROKEN_ue ('}')
#define BROKEN_ss ('~')
#endif


typedef struct
{
    char *str_short;
    char *str_long;
}
Shortcut;


extern char *AbkuerzungenExpandieren (char *strasse, Shortcut *abk);
extern char *ColumnReplace (char *record, int column, char separator,
			    char*replacement);
extern char *CStringToFixed (char *string, int length);
extern void FputsCharSet (char *s, FILE *stream, int cs);
extern int IbmIsoCStringCompare (char *s1, char *s2);
#if defined (HANDLE_BROKEN_DATAFILES)
extern char *IbmAndBrokenToIso (char *string);
#endif
extern char *IbmToIso (char *string);
extern char *IsoToAtari (char *s);
extern char *IsoToCapitals (char *string);
extern char *IsoToIbm (char *s);
extern char *OldPlz (char *s, char verkehrsgebiet);
extern char *OrtString (char *plz, char *ort, char *zustellamt, 
			char *ortsteil);
extern char *ReadSeparatedField (char *string, int pos, char separator);
extern char *StrasseString (char *strasse, char *hausnummer, char *postfach);
extern void StripBlanks (char *s);
extern int strntoi (char *s, int length);
extern Boolean UpdateString (char **old, char *new);
#endif
